import { defineComponent as $, computed as T, inject as m, openBlock as c, createElementBlock as u, Fragment as V, unref as F, normalizeStyle as y, withModifiers as C, normalizeClass as z, createElementVNode as f, toDisplayString as A, renderSlot as p, renderList as M, createBlock as k, withCtx as v, ref as B, provide as g, onMounted as j } from "vue";
const D = /* @__PURE__ */ f("g", { id: "caret-down" }, [
  /* @__PURE__ */ f("path", {
    id: "Vector",
    d: "M11.6646 4H2.33542C2.0556 4 1.89936 4.29436 2.07264 4.49531L6.73723 9.88431C6.87074 10.0386 7.12784 10.0386 7.26277 9.88431L11.9274 4.49531C12.1006 4.29436 11.9444 4 11.6646 4Z",
    fill: "#B8B8B8"
  })
], -1), E = [
  D
], N = /* @__PURE__ */ f("svg", {
  width: "14",
  height: "14",
  viewBox: "0 0 14 14",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ f("g", { id: "Folder" }, [
    /* @__PURE__ */ f("path", {
      id: "Vector",
      d: "M12.52 3.66055H7.135L5.3755 1.90742C5.35311 1.88559 5.32367 1.87332 5.293 1.87305H1.48C1.2145 1.87305 1 2.09648 1 2.37305V11.623C1 11.8996 1.2145 12.123 1.48 12.123H12.52C12.7855 12.123 13 11.8996 13 11.623V4.16055C13 3.88398 12.7855 3.66055 12.52 3.66055ZM11.92 10.998H2.08V2.99805H4.9075L6.7015 4.78555H11.92V10.998Z",
      fill: "#4A4A66"
    })
  ])
], -1), q = { class: "name" }, G = /* @__PURE__ */ $({
  __name: "FolderItem",
  props: {
    folder: {}
  },
  setup(n) {
    const o = n, e = T(() => ({
      paddingLeft: `${o.folder.level * (l || 20)}px`
    })), t = m("customize"), l = m("space"), d = m("toggleFolder");
    return (s, r) => (c(), u(V, null, [
      F(t) ? (c(), u("div", {
        key: 1,
        class: "folder-item yt-file-tree",
        style: y(e.value),
        onClick: r[1] || (r[1] = C((a) => F(d)(s.folder), ["stop"]))
      }, [
        p(s.$slots, "folder", { folder: s.folder })
      ], 4)) : (c(), u("div", {
        key: 0,
        class: "folder-item yt-file-tree",
        style: y(e.value),
        onClick: r[0] || (r[0] = C((a) => F(d)(s.folder), ["stop"]))
      }, [
        (c(), u("svg", {
          class: z([[s.folder.isOpen ? "open" : "close", s.folder.children.length > 0 ? "" : "hide"], "up-down menu-icon"]),
          width: "14",
          height: "14",
          viewBox: "0 0 14 14",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg"
        }, E, 2)),
        N,
        f("div", q, [
          f("span", null, A(s.folder.name), 1)
        ])
      ], 4)),
      (c(!0), u(V, null, M(s.folder.isOpen ? s.folder.children : [], (a, w) => (c(), k(O, {
        key: "TreeItem-" + w + "level-" + s.folder.level,
        item: a
      }, {
        folder: v(({ folder: i }) => [
          p(s.$slots, "folder", { folder: i })
        ]),
        file: v(({ file: i }) => [
          p(s.$slots, "file", { file: i })
        ]),
        _: 2
      }, 1032, ["item"]))), 128))
    ], 64));
  }
}), J = ["onClick"], K = /* @__PURE__ */ f("svg", {
  width: "14",
  height: "14",
  class: "file-icon",
  viewBox: "0 0 14 14",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ f("g", { id: "iframe" }, [
    /* @__PURE__ */ f("path", {
      id: "Vector",
      d: "M12.52 1H1.48001C1.21451 1 1.00001 1.2145 1.00001 1.48V12.52C1.00001 12.7855 1.21451 13 1.48001 13H12.52C12.7855 13 13 12.7855 13 12.52V1.48C13 1.2145 12.7855 1 12.52 1ZM2.08001 2.08H4.12001V11.92H2.08001V2.08ZM11.92 11.92H5.08001V5.08H11.92V11.92ZM5.08001 4.12V2.08H11.92V4.12H5.08001Z",
      fill: "#4A4A66"
    })
  ])
], -1), P = { class: "name" }, Q = ["onClick"], R = /* @__PURE__ */ $({
  __name: "FileItem",
  props: {
    file: {}
  },
  setup(n) {
    const o = n, e = T(() => ({
      paddingLeft: `${o.file.level * (d || 20)}px`
    })), t = m("setActiveFile"), l = m("customize"), d = m("space"), s = () => {
      t(o.file.id);
    };
    return (r, a) => F(l) ? (c(), u("div", {
      key: 1,
      class: "file-item yt-file-tree",
      style: y(e.value),
      onClick: C(s, ["stop"])
    }, [
      p(r.$slots, "file", { file: r.file })
    ], 12, Q)) : (c(), u("div", {
      key: 0,
      class: "file-item yt-file-tree",
      style: y(e.value),
      onClick: C(s, ["stop"])
    }, [
      K,
      f("div", P, [
        f("span", null, A(r.file.name), 1)
      ])
    ], 12, J));
  }
}), O = /* @__PURE__ */ $({
  __name: "TreeItem",
  props: {
    item: {}
  },
  setup(n) {
    const o = m("activeFile");
    return (e, t) => e.item.isFolder ? (c(), k(G, {
      key: 0,
      folder: e.item
    }, {
      folder: v(({ folder: l }) => [
        p(e.$slots, "folder", { folder: l })
      ]),
      file: v(({ file: l }) => [
        p(e.$slots, "file", { file: l })
      ]),
      _: 3
    }, 8, ["folder"])) : (c(), k(R, {
      key: 1,
      file: e.item,
      class: z({ active: F(o).has(e.item.id) })
    }, {
      file: v(({ file: l }) => [
        p(e.$slots, "file", { file: l })
      ]),
      _: 3
    }, 8, ["file", "class"]));
  }
}), H = (n, o = !1, e = 0, t = 0) => {
  const l = [];
  for (const d of n) {
    const { id: s, name: r, isFolder: a } = d;
    a ? l.push(
      Object.assign(d, {
        id: s,
        name: r,
        isFolder: !!a,
        level: e,
        isOpen: o,
        parentId: t,
        children: H(d.children, o, e + 1, d.id)
      })
    ) : l.push(
      Object.assign(d, {
        id: s,
        level: e,
        name: r,
        parentId: t,
        isFolder: !!a
      })
    );
  }
  return l;
}, L = (n, o, e) => {
  for (const t of n)
    if (t.id === e)
      for (const l of Object.keys(o))
        t[l] = o[l];
    else
      t.isFolder && L(t.children, o, e);
}, Z = (n, o) => {
  let e;
  for (const t of n)
    if (t.id === o) {
      e = t;
      break;
    } else
      t.isFolder && !e && (e = Z(t.children, o));
  return e;
}, I = (n, o) => {
  for (const e of n) {
    if (e.id === o && !e.isFolder)
      return !0;
    if (e.isFolder) {
      const t = e;
      if (I(t.children, o))
        return t.isOpen = !0, !0;
    }
  }
  return !1;
}, U = /* @__PURE__ */ $({
  __name: "Tree",
  props: {
    treeData: {},
    defaultFile: {},
    expandAll: { type: Boolean },
    customize: { type: Boolean },
    space: {}
  },
  emits: ["change"],
  setup(n, { expose: o, emit: e }) {
    const t = n, l = B([]), d = B(/* @__PURE__ */ new Set([])), s = (i) => {
      a(i.id, { isOpen: !i.isOpen });
    }, r = (i) => {
      const h = Z(l.value, i);
      h ? (d.value = /* @__PURE__ */ new Set([i]), e("change", h), w(i)) : console.error("This id is not a file");
    };
    g("setActiveFile", r), g("activeFile", d), g("toggleFolder", s), g("space", t.space), g("customize", t.customize), j(() => {
      t.expandAll ? l.value = H(t.treeData, !0) : l.value = H(t.treeData), t.defaultFile && r(t.defaultFile);
    });
    const a = (i, h) => {
      L(l.value, h, i);
    }, w = (i) => {
      I(l.value, i);
    };
    return o({
      update: a,
      expand: w,
      setActiveFile: r
    }), (i, h) => (c(!0), u(V, null, M(l.value, (S, b) => (c(), k(O, {
      key: "TreeItem-" + b,
      item: S
    }, {
      folder: v(({ folder: _ }) => [
        p(i.$slots, "folder", { folder: _ })
      ]),
      file: v(({ file: _ }) => [
        p(i.$slots, "file", { file: _ })
      ]),
      _: 2
    }, 1032, ["item"]))), 128));
  }
}), X = {
  install: (n) => {
    n.component("Tree", U);
  }
};
export {
  U as Tree,
  X as default
};
